unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, wcrypt2;

type
  TMainForm = class(TForm)
    txtFileName: TEdit;
    Label1: TLabel;
    BitBtn2: TBitBtn;
    OpenDialogUKB: TOpenDialog;
    SaveDlg: TSaveDialog;
    btDecode: TButton;
    OpenDialogEKB: TOpenDialog;
    Label2: TLabel;
    txtCryptoKey: TEdit;
    KeyName: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    txtSerNum: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    btCrypt: TButton;
    Label7: TLabel;
    lbContrSumma: TLabel;
    lbContrSummaNew: TLabel;
    lbGetCS: TLabel;
    lbGetCSNew: TLabel;
    procedure BitBtn2Click(Sender: TObject);
    procedure btDecodeClick(Sender: TObject);
    procedure btCryptClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;
type
 TEKBdata = record
    case Integer of
    0: (by: array[0..$4FF] of Byte);  // 1280 Byte
    1: (wo: array[0..$27F] of Word);  //  640 Word
    end;
 TEKBdataW = record
    case Integer of
    0: (by: array[0..$9FE] of Byte);  // 2560 Byte
    1: (wo: array[0..$4FF] of Word);  //  1280 Word
    end;
 TwRecord= record
    case Integer of
    0: (b: array[0..63] of Byte);
    1: (W: array[0..31] of Word);
    end;
 TEKB_info= record
    Name:string[92];
    SerNum:string[10]; // 
    CountInst:byte; //  
    CountTotal:byte; //  max 254
    fHRD:boolean; //  HRD    
 end;

var
  MainForm: TMainForm;
  rEKBdata,rEKBdata0,rEKBdataAx,rEKBdataAx0:    TEKBdata;
procedure EKB_DeCode67;
procedure EKB_DeCodeB9;
procedure EKB_DeCode0706;
procedure EKB_ContrSumma;
procedure CalcNewContrSumma;
function Get_CalcContrSumma:word;
function Get_CalcNewContrSumma:word;

implementation

{$R *.DFM}

procedure EKB_ContrSumma;
// 
var i:integer;
  wQuer:word;
begin
if rEKBdata.by[0]=ord('N')
 then
  begin
   wQuer:=0;
   for i:=0 to ($4FE-1) do wQuer:= Word(wQuer + rEKBdata.by[i]);
   rEKBdata.wo[$27F]:=wQuer xor 2805;
  end;
end;

procedure CalcNewContrSumma;
// 
var i:integer;
  wQuer, wXor, wDec :word;
begin
if rEKBdata.by[0]=ord('N')
 then
  begin
   wQuer:=0;
   wDec:=0;
   wXor:=0;
   for i:=0 to ($4F6-1) do
    begin
     wQuer:= Word(wQuer + rEKBdata.by[i]);
     wDec:= Word(wQuer - rEKBdata.by[i]);
     wXor:= Word(wQuer xor rEKBdata.by[i]);
    end;
   rEKBdata.wo[$27D]:=(wQuer xor wDec) xor wXor;
  end;
end;

function Get_CalcContrSumma:word;
// 
var i:integer;
  wQuer:word;
begin
if rEKBdata.by[0]=ord('N')
 then
  begin
   wQuer:=0;
   for i:=0 to ($4FE-1) do wQuer:= Word(wQuer + rEKBdata.by[i]);
   rEKBdata.wo[$27F]:=wQuer xor 2805;
  end;
end;

function Get_CalcNewContrSumma:word;
// 
var i:integer;
  wQuer, wXor, wDec :word;
begin
Get_CalcNewContrSumma:=0;
if rEKBdata.by[0]=ord('N')
 then
  begin
   wQuer:=0;
   wDec:=0;
   wXor:=0;
   for i:=0 to ($4F6-1) do
    begin
     wQuer:= Word(wQuer + rEKBdata.by[i]);
     wDec:= Word(wQuer - rEKBdata.by[i]);
     wXor:= Word(wQuer xor rEKBdata.by[i]);
    end;
   Get_CalcNewContrSumma:=(wQuer xor wDec) xor wXor;
  end;
end;

procedure EKB_DeCodeB9;
var i, ix, z: Integer;
    wMask: Word;
    bMask: Byte;
begin

   bMask:= $B9;
   begin
      for i:= 0 to ($4FE-1) do
      begin
         rEKBdata.by[i ] := rEKBdata.by[i ] XOR bMask;
         bMask:= byte(bMask) + 1;
      end;
   end;
end;

procedure EKB_DeCode0706;
var i, ix, z: Integer;
    wMask: Word;
    bMask: Byte;
begin

// Alles mit 0706hex + IDX XORen
   wMask:= $0706;
//   for i:= 0 to ((1280 / $20)-1) do   //1280 Byte / 32Byte = Anzahl der Blcke
   for i:=0 to 39 do // 40 Blcke
   begin
      for ix:= 0 to $10-1 do   // Je Block 16 Worte
      begin
         z:= (i*$10) + ix;     // BlockIndex * 16 + Index
         if z < $27F then      // CRC nicht umhacken
         rEKBdata.wo[z] := rEKBdata.wo[z] xor wMask;
      end;
      wMask:= Word(wMask +1);
   end;
end;

procedure EKB_DeCode67;
var i, ix, z: Integer;
    wMask: Word;
    bMask: Byte;
begin

   bMask:= $67;
   begin
      for i:= 0 to ($4FE-1) do
      begin
         rEKBdata.by[i ] := rEKBdata.by[i ] XOR bMask;
         bMask:= byte(bMask) + 1;
      end;
   end;
end;


function ErrToStr(e: int64): string;
begin
case e of
ERROR_BUSY: ErrToStr := 'ERROR_BUSY';
ERROR_CALL_NOT_IMPLEMENTED: ErrToStr := 'ERROR_CALL_NOT_IMPLEMENTED';
ERROR_INVALID_HANDLE: ErrToStr := 'ERROR_INVALID_HANDLE';
ERROR_INVALID_PARAMETER: ErrToStr := 'ERROR_INVALID_PARAMETER';
ERROR_MORE_DATA: ErrToStr := 'ERROR_MORE_DATA';
ERROR_NO_MORE_ITEMS: ErrToStr := 'ERROR_NO_MORE_ITEMS';
ERROR_NOT_ENOUGH_MEMORY: ErrToStr := 'ERROR_NOT_ENOUGH_MEMORY';
NTE_BAD_ALGID: ErrToStr := 'NTE_BAD_ALGID';
NTE_BAD_DATA: ErrToStr := 'NTE_BAD_DATA';
NTE_BAD_FLAGS: ErrToStr := 'NTE_BAD_FLAGS';
NTE_BAD_HASH: ErrToStr := 'NTE_BAD_HASH';
NTE_BAD_HASH_STATE: ErrToStr := 'NTE_BAD_HASH_STATE';
NTE_BAD_KEY: ErrToStr := 'NTE_BAD_KEY';
NTE_BAD_KEYSET: ErrToStr := 'NTE_BAD_KEYSET';
NTE_BAD_KEYSET_PARAM: ErrToStr := 'NTE_BAD_KEYSET_PARAM';
NTE_BAD_LEN: ErrToStr := 'NTE_BAD_LEN';
NTE_BAD_PROV_TYPE: ErrToStr := 'NTE_BAD_PROV_TYPE';
NTE_BAD_PUBLIC_KEY: ErrToStr := 'NTE_BAD_PUBLIC_KEY';
NTE_BAD_SIGNATURE: ErrToStr := 'NTE_BAD_SIGNATURE';
NTE_BAD_TYPE: ErrToStr := 'NTE_BAD_TYPE';
NTE_BAD_UID: ErrToStr := 'NTE_BAD_UID';
NTE_DOUBLE_ENCRYPT: ErrToStr := 'NTE_DOUBLE_ENCRYPT';
NTE_EXISTS: ErrToStr := 'NTE_EXISTS';
NTE_FAIL: ErrToStr := 'NTE_FAIL';
NTE_KEYSET_ENTRY_BAD: ErrToStr := 'NTE_KEYSET_ENTRY_BAD';
NTE_KEYSET_NOT_DEF: ErrToStr := 'NTE_KEYSET_NOT_DEF';
NTE_NO_KEY: ErrToStr := 'NTE_NO_KEY';
NTE_NO_MEMORY: ErrToStr := 'NTE_NO_MEMORY';
NTE_PROV_DLL_NOT_FOUND: ErrToStr := 'NTE_PROV_DLL_NOT_FOUND';
NTE_PROV_TYPE_ENTRY_BAD: ErrToStr := 'NTE_PROV_TYPE_ENTRY_BAD';
NTE_PROV_TYPE_NO_MATCH: ErrToStr := 'NTE_PROV_TYPE_NO_MATCH';
NTE_PROV_TYPE_NOT_DEF: ErrToStr := 'NTE_PROV_TYPE_NOT_DEF';
NTE_PROVIDER_DLL_FAIL: ErrToStr := 'NTE_PROVIDER_DLL_FAIL';
NTE_SIGNATURE_FILE_BAD: ErrToStr := 'NTE_SIGNATURE_FILE_BAD';
//: ErrToStr := '';
else ErrToStr := 'unknown error';
end;
end;

procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
Close;
end;


procedure TMainForm.btDecodeClick(Sender: TObject);
var cont: PChar;
    err: string;
    hProv: HCRYPTPROV; {  out- 001A9500}
    KeyExchKey, SessionKey, key : HCRYPTKEY;
    hash: HCRYPTHASH;
    flag, keyLen, l: DWORD;
    infile, outfile: file;
    tmp : PBYTE;
    data : TEKBdata; //array [0..1279] of byte;
    buf,buf1,buf2: array [0..1279] of byte;
    alg: ALG_ID;
    stream: boolean;
    dataLength:dword;
    ls, i, part :integer;

password, fname, fext: string; {'93CAA077BA474E1C8070SIFLS7PROF0503'}
plaintext, ciphertext,sProvider: string;
const //      -
fa:array [0..21] of string[34]= //CryptoKey array
{'SIFLS7PROF0503',}	('93CAA077BA474E1C8070SIFLS7PROF0503',
{'SIUPS7PROF0503',}	'A8D6FB148905C8980331SIUPS7PROF0503',
{'SIFLA171040503',}	'A4A3C87B16B88787CEDDSIFLA171040503',
{'SITTA171040503',}	'26538C94E25E32802EC5SITTA171040503',
{'SIFLA1PLCS0503',}	'DCAD3628F4286C1469CBSIFLA1PLCS0503',
{'SITTA1PLCS0503',}	'D9E6709CA732E044FA76SITTA1PLCS0503',
{'SIFLA1S7GR0503',}	'ACF6BBBB9228E1761151SIFLA1S7GR0503',
{'SITTA1S7GR0503',}	'DA9C8DB7DC955656BD52SITTA1S7GR0503',
{'SIFLA1SCL_0503',}	'0A13C6ED641CA9895517SIFLA1SCL_0503',
{'SITTA1SCL_0503',}	'B1ADADDA0D1C7CC6E7D9SITTA1SCL_0503',
{'SIFLA1ADMT0102',}	'805F84C44B6D88B1BFFESIFLA1ADMT0102',
{'SITTA1ADMT0102',}	'BF840FCE0685E13A40F4SITTA1ADMT0102',
{'SISLA1LOGS0102',}	'CE2F578BF6045D2540E0SISLA1LOGS0102',
{'SITTA1LOGS0102',}	'45E00D2F9B19EFD0CE44SITTA1LOGS0102',
{'SISLA1ESIG0102',}	'611C676DEB65793C157ESISLA1ESIG0102',
{'SITTA1ESIG0102',}	'EA8E57F2E515AEDA487ASITTA1ESIG0102',
{'SIMF0000010503',}	'FBFABA666182FDA82107SIMF0000010503',
{'SIMF0000020503',}	'C67AE969BBE9B434529FSIMF0000020503',
{'SIMF0000030503',}	'74BCE37B8A174BB4645DSIMF0000030503',
{'SIMF0000040503',}	'EF6E229320E457ED09ABSIMF0000040503',
{'SIMF0000050503',}	'6A6D4AEB8AE5C744BA88SIMF0000050503',
{'SIMF0000060503',}	'87140489C75B3BA8924ASIMF0000060503');
//    


begin
//password:='93CAA077BA474E1C8070SIFLS7PROF0503';
//30 char:='1;KII8??JI<?<M9K08?8N;JJ>K;<LN';
 KeyName.Clear;
 if OpenDialogEKB.Execute
  then
   begin
     plaintext:=OpenDialogEKB.FileName;
     txtFileName.Text:=OpenDialogEKB.FileName;
     fname:=ExtractFileName(plaintext);
     fext:=ExtractFileExt(plaintext);
     ciphertext:=ChangeFileExt(plaintext,'.UKB');
     i:=Pos('.',fname);
     fname:=Copy(fname,1,i-1);
     i:=0;
     while (i<22) and (Pos(fname,fa[i])=0) do inc(i); //   
     if i>21
      then Exit
      else
       begin
        password:=fa[i];  //if file exist in table
        txtCryptoKey.Text:=password;
         sProvider:='Microsoft Base Cryptographic Provider v1.0';
         dataLength:=1280;
         ls:=length(password);
         ls:=1;
         if not CryptAcquireContext(@hProv, nil, MS_DEF_PROV, 1, 0)
          then //CryptAcquireContext(hCryptProvider, nill,pszProvider, 1, 8  CRYPT_VERIFYCONTEXT )
           begin
            MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
            //exit;
            {  }
            //CryptAcquireContext(@hProv, nil, nil, PROV_RSA_FULL, 0);
            if not CryptAcquireContext(@hProv, nil, MS_DEF_PROV, PROV_RSA_FULL, CRYPT_NEWKEYSET)
             then //CryptAcquireContext(hCryptProvider,nill, pszProvider, 1, 0)
              begin
               MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
               exit;
              end;
           end;
          { -}
         if not CryptCreateHash(hProv, $8003, 0, 0, @hash)
          then  //(HCRYPTPROV hProv, $8003, nill, 0, HCRYPTHASH *phHash)
           begin
            MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
            exit;
           end;
         { }
         if not CryptHashData(hash, @password[1], $22, 0)
          then  // CryptHashData(hash, @password[1], length(password), 0)
           begin
            MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
            exit;
           end;
         {        RC4}
         if not CryptDeriveKey(hProv, $6801, hash, 0, @key)
          then //CryptDeriveKey(MainForm.hProv, $6801, hHashData, 0, @Form1.hKey)
           begin
            MessageDlg(' CryptDeriveKey: ' +
               ErrToStr(GetLastError), mtError, [mbOK], 0);
            exit;
           end;
         { -}
         { }
         //plaintext:='SIFLS7PROF0503.ekb';   //SIFLA171040503.ekb
         //ciphertext:='SIFLS7PROF0503.ukb'; //SIFLA171040503.ukb

         AssignFile(inFile, plaintext);
         AssignFile(outFile, ciphertext);
         reset(inFile, 1);
         rewrite(outFile, 1);
         {   }
         //GetMem(data, 1280);

         { }
         part:=0; //  0
         while not eof(inFile) do
          begin
           BlockRead(inFile, data.by, 1280, l);
           {push	offset pdwDataLen
          	push	offset EKB_0000	; pbData -  	 
 		        push	0		; dwFlags - , 	  
		        push	1		; Final	- , 	  
		        push	0		; hHash	-     
		        push	ds:phKey	; hKey -    
		        CryptDecrypt(hKey, hHash, Final, dwFlags, @pbData, @pdwDataLen)}
       //  if not CryptDecrypt(key, 0, eof (infile),  0, @data.by, @dataLength)
           if not CryptDecrypt(key, 0, true,  0, @data.by, @dataLength)
            then
             begin
              MessageDlg('Error of decrypting: ' + ErrToStr(GetLastError), mtError, [mbOK], 0);
              exit;
             end;
           rEKBdata.by:=data.by;
           EKB_DeCodeB9;  // Decode New maska B9
           EKB_DeCode0706;
           if part=0 then EKB_DeCode67;
           data.by :=  rEKBdata.by ;
           BlockWrite(outFile, data.by, l);
           inc(part);
          end;
         {    }
         //FreeMem(data, 1280);
        CloseFile(inFile);
        CloseFile(outFile);
{   if not CryptDestroyKey(SessionKey) then
       MessageDlg('   : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);}{  }
         if not CryptDestroyHash(hash) then
          begin
           MessageDlg('     : ' +
               ErrToStr(GetLastError), mtError, [mbOK], 0);
           exit;
          end;
         if not CryptReleaseContext(hProv, 0) then
           MessageDlg('  : ' + ErrToStr(GetLastError),
                      mtError, [mbOK], 0);
    end;
    fext:='';
    for i:=0 to $70 do
     fext:=fext+chr(rEKBdata.by[$2A2+i]);
     KeyName.Text:=fext;
    fext:='';
    for i:=0 to 19 do
     fext:=fext+chr(rEKBdata.by[$3A0+i]);
     txtSerNum.Text:=fext;
   end;
end;

//   
procedure TMainForm.btCryptClick(Sender: TObject);
var cont: PChar;
    err: string;
    hProv: HCRYPTPROV; {  out- 001A9500}
    KeyExchKey, SessionKey, key : HCRYPTKEY;
    hash: HCRYPTHASH;
    flag, keyLen, l: DWORD;
    infile, outfile: file;
    tmp : PBYTE;
    data : TEKBdata; //array [0..1279] of byte;
    buf,buf1,buf2: array [0..1279] of byte;
    alg: ALG_ID;
    stream: boolean;
    dataLength:dword;
    ls, i, part :integer;

password, fname, fext: string; {'93CAA077BA474E1C8070SIFLS7PROF0503'}
plaintext, ciphertext,sProvider: string;
const
fa:array [0..21] of string[34]= //CryptoKey array
{'SIFLS7PROF0503',}	('93CAA077BA474E1C8070SIFLS7PROF0503',
{'SIUPS7PROF0503',}	'A8D6FB148905C8980331SIUPS7PROF0503',
{'SIFLA171040503',}	'A4A3C87B16B88787CEDDSIFLA171040503',
{'SITTA171040503',}	'26538C94E25E32802EC5SITTA171040503',
{'SIFLA1PLCS0503',}	'DCAD3628F4286C1469CBSIFLA1PLCS0503',
{'SITTA1PLCS0503',}	'D9E6709CA732E044FA76SITTA1PLCS0503',
{'SIFLA1S7GR0503',}	'ACF6BBBB9228E1761151SIFLA1S7GR0503',
{'SITTA1S7GR0503',}	'DA9C8DB7DC955656BD52SITTA1S7GR0503',
{'SIFLA1SCL_0503',}	'0A13C6ED641CA9895517SIFLA1SCL_0503',
{'SITTA1SCL_0503',}	'B1ADADDA0D1C7CC6E7D9SITTA1SCL_0503',
{'SIFLA1ADMT0102',}	'805F84C44B6D88B1BFFESIFLA1ADMT0102',
{'SITTA1ADMT0102',}	'BF840FCE0685E13A40F4SITTA1ADMT0102',
{'SISLA1LOGS0102',}	'CE2F578BF6045D2540E0SISLA1LOGS0102',
{'SITTA1LOGS0102',}	'45E00D2F9B19EFD0CE44SITTA1LOGS0102',
{'SISLA1ESIG0102',}	'611C676DEB65793C157ESISLA1ESIG0102',
{'SITTA1ESIG0102',}	'EA8E57F2E515AEDA487ASITTA1ESIG0102',
{'SIMF0000010503',}	'FBFABA666182FDA82107SIMF0000010503',
{'SIMF0000020503',}	'C67AE969BBE9B434529FSIMF0000020503',
{'SIMF0000030503',}	'74BCE37B8A174BB4645DSIMF0000030503',
{'SIMF0000040503',}	'EF6E229320E457ED09ABSIMF0000040503',
{'SIMF0000050503',}	'6A6D4AEB8AE5C744BA88SIMF0000050503',
{'SIMF0000060503',}	'87140489C75B3BA8924ASIMF0000060503');
//    


begin
//password:='93CAA077BA474E1C8070SIFLS7PROF0503';
//30 char:='1;KII8??JI<?<M9K08?8N;JJ>K;<LN';
 KeyName.Clear;
 if OpenDialogUKB.Execute
  then
   begin
     plaintext:=OpenDialogUKB.FileName;
     txtFileName.Text:=OpenDialogUKB.FileName;
     fname:=ExtractFileName(plaintext);
     fext:=ExtractFileExt(plaintext);
     ciphertext:=ChangeFileExt(plaintext,'.EKB');
     i:=Pos('.',fname);
     fname:=Copy(fname,1,i-1);
     i:=0;
     while (i<22) and (Pos(fname,fa[i])=0) do inc(i);
     if i>21
      then Exit
      else
       begin
        password:=fa[i];
        txtCryptoKey.Text:=password;
         sProvider:='Microsoft Base Cryptographic Provider v1.0';
         dataLength:=1280;
         ls:=length(password);
         ls:=1;
         if not CryptAcquireContext(@hProv, nil, MS_DEF_PROV, 1, 0)
          then //CryptAcquireContext(hCryptProvider, nill,pszProvider, 1, 8  CRYPT_VERIFYCONTEXT )
           begin
            MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
            //exit;
            {  }
            //CryptAcquireContext(@hProv, nil, nil, PROV_RSA_FULL, 0);
            if not CryptAcquireContext(@hProv, nil, MS_DEF_PROV, PROV_RSA_FULL, CRYPT_NEWKEYSET)
             then //CryptAcquireContext(hCryptProvider,nill, pszProvider, 1, 0)
              begin
               MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
               exit;
              end;
           end;
          { -}
         if not CryptCreateHash(hProv, $8003, 0, 0, @hash)
          then  //(HCRYPTPROV hProv, $8003, nill, 0, HCRYPTHASH *phHash)
           begin
            MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
            exit;
           end;
         { }
         if not CryptHashData(hash, @password[1], $22, 0)
          then  // CryptHashData(hash, @password[1], length(password), 0)
           begin
            MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
            exit;
           end;
         {        RC4}
         if not CryptDeriveKey(hProv, $6801, hash, 0, @key)
          then //CryptDeriveKey(MainForm.hProv, $6801, hHashData, 0, @Form1.hKey)
           begin
            MessageDlg('Error CryptDeriveKey: ' +
               ErrToStr(GetLastError), mtError, [mbOK], 0);
            exit;
           end;
         { -}
         { }
         //plaintext:='SIFLS7PROF0503.ekb';   //SIFLA171040503.ekb
         //ciphertext:='SIFLS7PROF0503.ukb'; //SIFLA171040503.ukb

         AssignFile(inFile, plaintext);
         AssignFile(outFile, ciphertext);
         reset(inFile, 1);
         rewrite(outFile, 1);
         {   }
         //GetMem(data, 1280);

         { }
         part:=0; //  0
         while not eof(inFile) do
          begin
           BlockRead(inFile, data.by, 1280, l);
           rEKBdata.by:=data.by;

    fext:='';
    for i:=0 to $70 do
     fext:=fext+chr(rEKBdata.by[$2A2+i]);
     KeyName.Text:=fext;
    fext:='';
    for i:=0 to 19 do
     fext:=fext+chr(rEKBdata.by[$3A0+i]);
     txtSerNum.Text:=fext;

           if part=0 then EKB_DeCode67;
           EKB_DeCodeB9;  // Decode New maska B9
           EKB_DeCode0706;
           data.by :=  rEKBdata.by ;
           inc(part);
        //    .
        //  push    pCryptDataLength	; dwBufLen
        //  push    offset pCryptDataLength ; pdwDataLen
        //  push    offset EKB_0000 ; pbData	-    
        //  push    0	; dwFlags - ,    
        //  push    1 ; Final - ,    
        //  push    0 ; hHash -     
        //  push    phCryptKey ; hKey -	   
        //  call    CryptEncrypt ; CryptEncrypt(hKey, hHash, Final, dwFlags, @pbData, @pdwDataLen, dwBufLen)
            if not CryptEncrypt(key, 0, true, 0, @data.by, @dataLength, 1280)
             then
              begin
               MessageDlg('Error of crypting: ' + ErrToStr(GetLastError), mtError, [mbOK], 0);
               exit;
              end;
           BlockWrite(outFile, data.by, l);
          end;
         {    }
         //FreeMem(data, 1280);
        CloseFile(inFile);
        CloseFile(outFile);
{   if not CryptDestroyKey(SessionKey) then
       MessageDlg('   : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);}{  }
         if not CryptDestroyHash(hash) then
          begin
           MessageDlg('     : ' +
               ErrToStr(GetLastError), mtError, [mbOK], 0);
           exit;
          end;
         if not CryptReleaseContext(hProv, 0) then
           MessageDlg('  : ' + ErrToStr(GetLastError),
                      mtError, [mbOK], 0);
    end;
   end;
end;

end.
